{Feedback Servo Demo}

CON
        _clkmode = xtal1 + pll16x    'Standard clock mode 
        _xinfreq = 5_000_000         '* crystal frequency = 80 MHz
        Control = 15                 'control pin
        Feedback = 14                'feedback pin
        sensor = 12                  'wheel sensor (not used)
        sync = 0                     'engineering
VAR
  byte  Cog
  long  temp, commanded, actual, random
  long  angle, oldangle
  
OBJ
  pst      : "parallax serial terminal"
  FBS      : "FBServo"
  
PUB main                                     'where to store cnt
  pst.Start (115_200)                        'start up ser terminal
  pst.str(String("hello, world   "))         'runs in cog 1
  pst.NewLine
  waitcnt(clkfreq/10+cnt)

  cog := FBS.start(control, feedback)         'specify pin numbers   
  pst.str(string("started position cog: "))
  pst.dec(cog)
  pst.newline
  
  dira[sync] := 1                  'scope probe 
'  FBS.SetPos(180)                    'known spot 
  
  repeat 200                       'force open loop velocity   
     FBS.Width(1483)
     angle := (FBS.getpos)         'get, display current position
     pst.dec(angle)
     pst.str(string("   "))
     pst.dec(angle-oldangle)
     oldangle := angle
     pst.newline
     waitcnt(clkfreq/100+cnt)   

  fbs.width(1500)                  'stop servo
  
  repeat commanded from 5 to 355 step 5
     outa[sync] := 1                 'sync
     FBS.SetPos(commanded)   'set position, returns ending position
     outa[sync] := 0       
     waitcnt(clkfreq*2 + cnt)
     actual := FBS.getpos
     pst.str(string("Commanded: "))
     pst.dec(commanded)
     pst.str(string("   Actual: "))
     pst.dec(actual)
     pst.newline

  repeat 100
     ?random
     commanded := || random           'drop sign bit
     commanded := commanded // 360    'range 0..359
     outa[sync] := 1
     FBS.SetPos(commanded)
     outa[sync] := 0
     pst.str(string("Command: "))
     pst.dec(commanded)          
     waitcnt(clkfreq*5 + cnt)          'wait for it to settle      
     actual :=FBS.getpos
     pst.str(string("   Actual: "))
     pst.dec(actual)
     pst.newline


  repeat                                'stop here        
  
          